#define _BSD_SOURCE
#define _XOPEN_SOURCE
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <json.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#include "config.h"
#include "eventmanager.h"
#include "actionmanager.h"

int parseconfig(char *filename)
{
   json_object *config;

   config = json_object_from_file(filename);

   em_parseevents(config);
   am_parseactions(config);

   json_object_put(config);

   return 0;
}

int get_int(json_object *json, char *key, int *val)
{
   json_object *o;

   if(!(o = json_object_object_get(json, key)) || !json_object_is_type(o, json_type_int)) {
      *val = -1;
      return -1;
   }

   *val = json_object_get_int(o);

   return 0;
}

int get_string(json_object *json, char *key, char **val)
{
   json_object *o;

   if(!(o = json_object_object_get(json, key)) || !json_object_is_type(o, json_type_string)) return -1;

   *val = (char *)json_object_get_string(o);

   return 0;
}

int get_boolean(json_object *json, char *key, int *val)
{
   json_object *o;

   if(!(o = json_object_object_get(json, key)) || !json_object_is_type(o, json_type_boolean)) return -1;

   *val = json_object_get_boolean(o);

   return 0;
}
